(define (domain gripper)
   
    (:requirements :typing :action-costs)
   
    (:types room ball arm)

    (:predicates
        (at-robby ?x - room)
        (at ?x - ball ?y - room)
        (free ?x - arm)
        (carry ?x - ball ?y - arm)
    )

    (:functions   
       (length ?rooma - room ?roomb - room)
       (total-cost)
    )
   
    (:action move
        :parameters (?x - room ?y - room)
        :precondition (at-robby ?x)
        :effect (and (at-robby ?y)
                (not (at-robby ?x))
                (increase (total-cost) (length ?x ?y))
    ))

    (:action pick
       :parameters (?obj - ball ?room - room ?gripper - arm)
       :precondition  (and (at ?obj ?room) (at-robby ?room) (free ?gripper))
       :effect (and (carry ?obj ?gripper)
		                (not (at ?obj ?room)) 
		                (not (free ?gripper))
                    (increase (total-cost) 1)
    ))

    (:action drop
       :parameters (?obj - ball ?room - room ?gripper - arm)
       :precondition  (and (carry ?obj ?gripper) (at-robby ?room))
       :effect (and (at ?obj ?room)
		                (free ?gripper)
		                (not (carry ?obj ?gripper))
                    (increase (total-cost) 1)
    ))

)
